%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function openDesignManagerDialog
    try
		evalin('base', 'createDMConnection');
		dmConn = evalin('base', 'dmConnection');
	catch
		return;
	end	
	
	if isjava(dmConn) == 0
		return;
    end	
    
    action = char(dmConn.openDesignManagerDialog());
    if isempty(action) == 1
        return;
    end
    
    mdlDir = char(dmConn.getSimModelPathDir());
    if isempty(mdlDir) == 0
        addpath(mdlDir);
    end
    
    if strcmp(action, 'Open') == 1
        openSimulinkModelFromDM();
        return;
    elseif strcmp(action, 'Navigate') == 1
         navigateToDMServer('');
         return;    
    end
    
    mdlPath = char(dmConn.openSelectSimulinkModelDialog(action));
    if isempty(mdlPath) == 1
        return;
    end
    
    mdlDir = char(dmConn.getSimModelPathDir());
    if isempty(mdlDir) == 0
        addpath(mdlDir);
    end
    
    disp('Loading model...');
    warning('off','Simulink:modelReference:modelNotFound');
    sys = load_system(mdlPath);
    warning('on','Simulink:modelReference:modelNotFound');
    
    if isempty(sys) == 1
        return;
    end
    
    mdlName = get_param(sys, 'name');
    
    if strcmp(action, 'Publish') == 1
        %make sure the model window is opened
        msg = sprintf('Opening "%s"...', mdlName); 
        disp(msg);
        open_system(sys);
        
        publishSimulinkModelToDM();
        
    elseif strcmp(action, 'Move') == 1    
        %make sure the model window is opened
        msg = sprintf('Opening "%s"', mdlName); 
        disp(msg);
        open_system(sys);
        
        moveSimulinkModelToDM();
        
    elseif strcmp(action, 'Lock') == 1
        lockSimulinkModelInDM();
        
    elseif strcmp(action, 'Unlock') == 1    
        unlockSimulinkModelInDM();
        
    elseif strcmp(action, 'Disconnect') == 1    
        disconnectSimulinkModelFromDM();
    end    
end