%% Licensed Materials - Property of IBM
%% Restricted Materials of IBM. Reproduction, modification and redistribution are prohibited.
%% IBM Rational Rhapsody Design Manager
%%  Copyright IBM Corporation 2013 
%% U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

function unlockSimulinkModelInDM(bUponCloseModel)
	postSaveFcn = get_param(gcs, 'PostSaveFcn');
	if strcmp(postSaveFcn, 'saveSimulinkModelToDM()') == 0
		disp('Model is not connected to DM, can not unlock model');
		return;
	end
	
	try
		evalin('base', 'createDMConnection');
		dmConn = evalin('base', 'dmConnection');
	catch
		return;
	end	
	
	if isjava(dmConn) == 0
		return;
	end	
	
	simMdlName = get_param(gcs,'name');
	if dmConn.isSimulinkModelLocked(simMdlName) == 0
		disp('Model already unlocked');
		return;
	end	
	
	%check if we need to save
	dirtyFlag = get_param(gcs,'dirty');
	if strcmp(dirtyFlag, 'off') == 1
		action = 'Unlock';
	else
		action = char(dmConn.openUnlockingModelDialog(bUponCloseModel));
	end	
	
	if isempty(action) == 0
		if strcmp(action, 'SaveUnlock') == 1
			saveSimulinkModelToDM(0);
		end
		if dmConn.unlockSimulinkModel(simMdlName) == 1
			msg = sprintf('Succeeded unlocking model %s on DM.', simMdlName); 
		else
			msg = sprintf('Failed unlocking model %s on DM.', simMdlName); 
		end	
		disp(msg);
	end
end